#include "grafik.h"
#ifndef SCALE
#define SCALE 1
#endif

#ifdef GAG
#define GAG_ 3
#else
#define GAG_ 1
#endif

/* X-Window-Code geklaut und angepasst von "guimauve2" */

void init_x () {

  dis = XOpenDisplay  ( NULL );
  disDepth = -1;
  if ( dis != NULL)
    {
      disScreen = DefaultScreen ( dis );
      disDepth  = DefaultDepth  ( dis , disScreen );
      disWidth  = DisplayWidth  ( dis , disScreen );
      disHeight = DisplayHeight ( dis , disScreen );
    }
    
  if ( disDepth != 16 )
    {
      fprintf ( stderr , "Fehler: Farbtiefe ist %d, nicht 16\n" , disDepth );
      if ( disDepth > 0 ) XCloseDisplay  ( dis );
      exit (1);
    }

  winRoot                  = DefaultRootWindow ( dis );
  winAttr.border_pixel     = BlackPixel ( dis , disScreen );
  winAttr.background_pixel = BlackPixel ( dis , disScreen );
  winMask                  = CWBackPixel | CWBorderPixel;
 
  win = XCreateWindow ( dis , winRoot , X , Y , W * SCALE * GAG_ , H * SCALE ,
                        BORDER , disDepth ,
			InputOutput , CopyFromParent , winMask , &winAttr );

  XStoreName ( dis , win , NAME );

  XSelectInput ( dis , win , KeyPressMask );

  winHint.flags = PPosition | PMinSize | PMaxSize ;
  winHint.x = X;                     
  winHint.y = Y;
  winHint.max_width  = winHint.min_width  = W * SCALE * GAG_;
  winHint.max_height = winHint.min_height = H * SCALE;
  XSetWMNormalHints ( dis , win , &winHint );

  XClearWindow ( dis , win );
  XMapRaised ( dis , win );
  XFlush ( dis );

  buffer = ( EA_PIXEL * ) malloc ( 2 * W * H );
  buffer_byte = ( unsigned char * ) buffer;
  buffer2 = (SCALE == 1) ? 
    buffer : 
    ( EA_PIXEL * ) malloc ( 2 * W * SCALE * H * SCALE );
  if ((buffer2 == NULL) || (buffer == NULL))
    { 
      fprintf ( stderr , "Fehler: No RAM for X-Buffers!\n" );
      XDestroyWindow ( dis , win );
      XCloseDisplay  ( dis );
      exit(1);
    }
  xim = XCreateImage ( dis , CopyFromParent , disDepth , ZPixmap , 0 ,
		       ( unsigned char * ) buffer2 , W * SCALE , H * SCALE , 
		       disDepth , W * 2 * SCALE ); /* last Arg: XSize(bytes) */

  gcVal.foreground = 0;     
  gcVal.background = 0;
  gcMask           = GCForeground | GCBackground;
  gc = XCreateGC ( dis , win , gcMask , &gcVal );

}


int event_x () {

  XEvent XEv;

  return ( ! XCheckWindowEvent ( dis , win , KeyPressMask , &XEv ) ); 
}


void close_x () {

  XFreeGC        ( dis , gc );
  XDestroyImage  ( xim );
  XDestroyWindow ( dis , win );
  XCloseDisplay  ( dis );     

}

void show_x () {

  if (SCALE == 1)
  { XPutImage ( dis , win , gc , xim , 0 , 0 , 0     , 0     , W , H );
#ifdef GAG
    XPutImage ( dis , win , gc , xim , 0 , 0 , W     , 0     , W , H );
    XPutImage ( dis , win , gc , xim , 0 , 0 , W + W , 0 * H , W , H );
#endif
  } // Ende SCALE == 1
  else
  { if ( (sizeof(EA_PIXEL) != 2) || (SCALE != 2) ) 
       // nur fuer Scale 2 und 15/16bit ist bisher Schnell-Code fertig
    { int x, y, x2, y2, n;
      EA_PIXEL now;
      for (y=0, y2=0;  y < (W * H);  y+= W , y2+= (W * SCALE) )
      { for (x=0, x2=0; x < W; x++)
        { now = buffer[y + x];
          for (n=0; n < SCALE; n++) { buffer2[y2 + x2] = now; x2++; };
        };
        for (n=1; n < SCALE; n++)
        { memcpy((void *)(buffer2 + y2 + (W * SCALE)) , \
                 (void *)(buffer2 + y2) , W * SCALE * sizeof(EA_PIXEL));
          y2 += W * SCALE;
        };
      };
    } 
    else // Glueck gehabt - Schnell-Code kann verwendet werden:
    { __asm__("
         pushl %%ebp
	         pushal
         cld
              movl %%ecx,%%ebx
         .align 16
      2: movl %%edi,%%ebp
      1: lodsw; stosw; stosw
         loop 1b
           movl %%esi,%%eax
         movl %%ebp,%%esi
              movl %%ebx,%%ecx; 
         rep; movsl
           movl %%eax,%%esi
              movl %%ebx,%%ecx
         decl %%edx
         jnz 2b
         	popal
         popl %%ebp
              "::"D"(buffer2),"S"(buffer),"c"(W),"d"(H)
                /* : "esi","edi","eax","ecx","edx","ebx" */
             );
      // Funktionsweise: alle Pixel verdoppelt kopieren,
      // dann ganze Ziel-Zeile verdoppeln (PS: 1b = 1, backward)
      // und das Ganze fuer jede Zeile wiederholen
      // ebx ist Backup von ecx,  eax ist Pixel bzw. Backup von esi
      // ebp ist Backup eines Zielzeilenanfangs
      // ebp wird von Hand gesichert - GCC 2.7.2 macht das nicht korrekt!?!
    }; // Ende Schnell-Code
    
      XPutImage ( dis , win , gc , xim , 0 , 0 , 0             , 0 , W * SCALE , H * SCALE );
#ifdef GAG
      XPutImage ( dis , win , gc , xim , 0 , 0 , W * SCALE     , 0 , W * SCALE , H * SCALE ); 
      XPutImage ( dis , win , gc , xim , 0 , 0 , W * SCALE * 2 , 0 , W * SCALE , H * SCALE ); 
#endif
    }; // Ende SCALE != 1
};
