// #include <math.h>
// #include <stdio.h>

// #include <SDL.h>  //die SDL macht den Code von der Farbtiefe des X-Servers
//                   //unabhaengig.(falls >= 8bit)

// war fest 640x480
#define MAX_SINEINDEX W
#define MAX_SAMPLEINDEX W
#define MAX_XRES W
#define MAX_YRES H


#define MAX_PICADDRESS (MAX_YRES * MAX_XRES)


unsigned char sint[MAX_SINEINDEX];

#ifdef ANDREAS
unsigned char virtpict[MAX_PICADDRESS];
unsigned char virtpict2[MAX_PICADDRESS];
unsigned char virtscr2[MAX_PICADDRESS];
#endif

unsigned int transtab[MAX_PICADDRESS];

void createtables(int a);

void createtables(int a){
    unsigned int t;
//  double t1,t2,t3;

  for (t=0; t < MAX_SINEINDEX; t++){
		sint[t] = (unsigned char)(127.0 * tan((float)(a+t)/ \
			(float)MAX_SINEINDEX*3.1416));	
	/*	
	  t1 = exp(sin((double)(t+a)/256*3.1415));
	  t1 /= exp(1.0);
	  t1 -= 0.5;
	  sint[t]=((unsigned char)(127*t1));
	*/
  }
}

//Interpolation (ungewichtets arithmetisches Mittel der umliegenden acht Pixel
//ohne Bercksichtigung der Tatsache dass links und obenliegende Pixel schon
//interpoliert wurden)

void vary(unsigned char *vscreen){  
  int x,y;
  int tmp,tmpoffset,boffset;
//  int lb = 0,ub = MAX_PICADDRESS;

  for(y=0; y< MAX_YRES; y++)  
	for(x=0; x< MAX_XRES; x++){
	  boffset = y*MAX_XRES+x;
	  //	  tmp = vscreen[boffset];
	  tmp = 0;
	  tmpoffset = boffset-1;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset+1;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset-MAX_XRES;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset+MAX_XRES;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset-MAX_XRES - 1;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset-MAX_XRES  + 1;	  
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset] ;
	  tmpoffset = boffset+MAX_XRES  - 1;	  
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset+MAX_XRES  + 1;	  
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  vscreen[boffset] = tmp >> 3; 
	}
}

void varytab(unsigned int *vscreen){  //Interpolation der Translationstabelle
  int x,y;
  int tmp,tmpoffset,boffset;

//  int lb = 0,ub = MAX_PICADDRESS;

  for(y=0; y< (MAX_YRES >> 1); y++)  
	for(x=0; x< (MAX_XRES >> 1); x++){
	  boffset = y*MAX_XRES+x;
	  //	  tmp = vscreen[boffset];
	  tmp = 0;
	  tmpoffset = boffset-1;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset+1;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset-MAX_XRES;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset+MAX_XRES;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset-MAX_XRES - 1;
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset-MAX_XRES  + 1;	  
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset] ;
	  tmpoffset = boffset+MAX_XRES  - 1;	  
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  tmpoffset = boffset+MAX_XRES  + 1;	  
	  //	  if(lb < tmpoffset && tmpoffset < ub)
	  tmp += vscreen[tmpoffset];
	  vscreen[boffset] = tmp >> 3; 
	}
}

	
//Ich hab angefangen Translationstabellen zu benutzen um z.B. das ganze Bild
//zu rotieren (Test mit Rundungsfehlern). Eine Idee die ich schon ewig 
//habe ist es eine Translationstabelle zu erstellen, mit der man die 
//Spiegelungen im Oszi auf ein n-Eck statt dem 4-Eck erweitern knnte.
//Das wre nher an einem Kaleidoskop. Ansonsten kann man natrlich tausend
//andere schne Dinge damit machen.
	  
void gentranstab(unsigned int* transtab) { 
  int offset;
  int x,y;
//  float temp;
  int xoff,yoff;
  int xn = (MAX_XRES >> 1);
  int yn = (MAX_YRES >> 1);
  double angle = (1.0 / 127.0) * M_PI;

  for (y=0; y < MAX_YRES; y++)
	for (x=0; x < MAX_XRES; x++){
	  xoff = xn + cos(angle) * (x - xn) - sin(angle) * (y - yn);
	  yoff = yn + sin(angle) * (x - xn) + cos(angle) * (y - yn);
	  //xoff = xn + (0.9*(x-xn))+(0.1*(y-yn)) * cos(angle);
	  //yoff = yn + (0.9*(y-yn))-(0.1*(x-xn)) * sin(angle);
	  offset = (yoff * MAX_XRES + xoff) % (MAX_PICADDRESS-1);
	  transtab[y*MAX_XRES+x] = offset;
  }

  /*  printf("x :    %d\t y:    %d\t off :    %d\n",x,y,y * MAX_XRES + x);
      printf("xoff : %d\t yoff: %d\t offset : %d\n",xoff,yoff,
      yoff * MAX_XRES + xoff);
   */
  
  printf("freedom ");

}



void applytranstab(unsigned char* virtscr){
  int x,y;
//  unsigned char scr[MAX_PICADDRESS];

  for(y=0;y<MAX_YRES;y++)
	for(x=0;x<MAX_XRES;x++)
	  virtpict[y*MAX_XRES+x] = virtscr[transtab[y*MAX_XRES+x]];

  for(y=0;y<MAX_YRES;y++)
	for(x=0;x<MAX_XRES;x++)
	  virtscr[y*MAX_XRES+x] = virtpict[y*MAX_XRES+x];
}

unsigned char* gentexture(unsigned char *virtscr){

  //temporary variables

  int offset,offset2,offset3;
  int sindump,sindump2;
  unsigned char *sample;
  //  unsigned char sample[MAX_SAMPLEINDEX];
  //  int sint[MAX_SINEINDEX];
  //  char virtscr[MAX_PICADDRESS];
  int x,y;

  //quick hack !!!
  sample = &sint[0]; 
  	// da keine samples da sind nehm ich einfach die Kurventabelle
        // und verschieb sie in jedem Frame, damit sich was tut.
  //end of quick hack


  //Hier ist die aufloesungsunabhaengige Variante der Texturberechnung.

  for(y = 0;y < (MAX_YRES >> 1); y++){
	  
	  offset = y*MAX_XRES;
	  sindump = (sint[y]+sample[y]);
	  sindump2 = (sint[(MAX_YRES-y)]+sample[(MAX_YRES-y)]);
	
	  for(x=0;x < (MAX_XRES >> 1); x++) {
		  
		  offset2 = offset+x;
		  offset3 = (sint[MAX_XRES-x]+sindump)&255;
		  virtpict[offset2] = sample[offset3] >> 1;
		  offset3 = (sint[x]+sindump2)&255;    //sindump2
		  virtpict2[offset2]= sample[offset3] >> 1;
		  virtscr[offset2] = virtpict[offset2]+virtpict2[offset2];
		}
	}
   
	vary(virtscr);

		
	for(y=0;y<(MAX_PICADDRESS >> 1);y+=MAX_XRES)
	  for(x=0;x< (MAX_XRES >> 1);x++){
		offset2 = y+(MAX_XRES-1)-x;
		offset = y+x;
		virtscr[offset2] = -virtscr[offset];
	  }
	
	for(x=0;x<(MAX_PICADDRESS >> 1);x++) {virtscr[(MAX_PICADDRESS-1)-x] = virtscr[x];}

	for(x=0;x<MAX_XRES;x++){
	  virtscr[x] = 0;
	  virtscr[(MAX_PICADDRESS-1)-x] = 0;}
	
	/*	for(x=0;x < MAX_PICADDRESS; x++)
		virtscr[x] = virtscr[transtab[x]];*/
	
/*  	waitvretrace(); */
/*  	morphpal(); */
/*  	changecol(); //color reset auskommentiert!! */
	
/*  	setpalette(); */
/*  	copyfullscreen(virtscr); */

/* *** */
/* *** */
// return was missing
return NULL;
}

#ifdef ANDREAS

int main(){
// ...
  createtables(0);
  for(i = 0; i < 256; i++){
	cols[i].r = (i); cols[i].g = (i%32); cols[i].b = (-i);  }   
//  SDL_SetColors(vscreen,cols,0,255);
  gentranstab(transtab);
  varytab(transtab);
  off=(unsigned char*) vscreen -> pixels;

  for(count = 0; count < 1500; count++){
	createtables(4*count);
	gentexture(virtscr2);
//	SDL_LockSurface(vscreen);   //  applytranstab(virtscr2);
	for(i=0;i<MAX_PICADDRESS;i++){	off[i] = virtscr2[i];	}	
//	SDL_UnlockSurface(vscreen); //	SDL_UpdateRect(vscreen, 0,0,0,0);
  }
// ...
}

#endif
